from abc import ABC, abstractmethod
from typing import Union

import discord
from cpl_query.extension import List
from discord.ext.commands import Context


class MessageServiceABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    async def delete_messages(self, messages: List[discord.Message], guild_id: int): pass
    
    @abstractmethod
    async def delete_message(self, message: discord.Message): pass
    
    @abstractmethod
    async def send_channel_message(self, channel: discord.TextChannel, message: Union[str, discord.Embed]): pass
    
    @abstractmethod
    async def send_dm_message(self, message: Union[str, discord.Embed], receiver: Union[discord.User, discord.Member]): pass
    
    @abstractmethod
    async def send_ctx_msg(self, ctx: Context, message: Union[str, discord.Embed], file: discord.File = None, is_persistent: bool = False): pass
